Program MetaPhysic;
global
	grav=4;
	thrust=16;
	ballstart[1]=2900,300;
	level=0;
	triggered;
	//level file reader globals
	power[3]=1,256,256*256,256*256*256;
	string line[100];//up to 100 lines, should be enough?
begin
	set_mode(320,240,16);
	load_fpg("metaphys.fpg");
	PLAY_SONG(load_song("metaphys.it"),-1);
	put_screen(0,11);
	startlevel();
end
process ball();
private;
	Xmovement;
	ymovement;	
begin
	resolution=10;
	graph=1;
	x=ballstart[0];
	y=ballstart[1];
	loop
		frame;
		xmovement-=grav;
		if(key(_left))xmovement-=thrust-grav;end
		if(key(_right)or key(_control)or key(_alt))xmovement+=thrust+grav;end
		if(key(_up))ymovement-=10;end
		if(key(_down))ymovement+=10;end
		angle-=500*ymovement;
		x+=xmovement;
		y+=ymovement;
		if(x<160 or x>3040 or y<160 or y>2240 or collision(type wall) or collision(type slider))
			hit(id);
		end
	end
end;
process endball(x,y);
begin
	z=-1;
	resolution=10;
	graph=1;
	while(size<160);
		size+=5;
		angle+=10000;
		frame;
	end
	while(size>0);
		size-=10;
		angle+=10000;
		frame;
	end
end
process wall(x,y,size_x,size_y);
begin
	resolution=10;
	graph=11;
	size_x*=50;
	size_y*=50;
	loop
		frame;
	end
end
process warp(x,y,fake)
private;
	animation;
	ball;
begin
	resolution=10;
	loop
		graph=animation/3+2;
		if(++animation >=24)
			animation=0;
		end
		if(ball=COLLISION(type ball))
			switch(fake)
				case(0):
					writeangle(160,120,"congrats",270);
					signal(ball,s_kill);
					endball(x,y);
					loop
						if(key(_enter))
							startlevel();
						end 
						frame;
					end
				end
				case(1):
					cross(x,y);
					fake=2;
				end
			end
		end
		frame;
	end
end;
process cross(x,y)
private
	animation;
begin
	graph=10;
	resolution=10;
	angle=45000;
	size=250;
	while(size>100)frame;animation+=10; size-=animation;end
	frame;
	animation = -3*animation/5;
	size-=animation;
	frame;
	while(size>100)frame;animation+=10; size-=animation;end
	frame;
	loop
		frame;
	end
end
process trigger(x,y,duration)
private;
	text;
	time;
begin
	graph=16;
	resolution=10;
	loop
		frame;
		if(time-timer[0]<0)
			triggered=0;
		end
		if(exists(text))signal(text,s_kill);end
		if(COLLISION(type ball))
			triggered=1;
			time=timer[0]+duration*100;
		end
		switch(triggered)
			case(0):graph=16;end
			case(1):
				graph=17;
				text=writeangle(x/10-12,y/10,itoa((time-timer[0])/100),270);
			end
		end
	end
end
process slider(x,y,size_x,size_y,angle,anim)
private
	trig;
	origsize;
begin
	z=-2;
	graph=15;
	resolution=10;
	angle*=1000;
	size_y*=20;
	origsize=size_x;
	loop
		frame;
		if(triggered!=trig)
			trig=triggered;
		end
		if(trig==1 and size_x>0)
			size_x-=anim;
		end
		if(trig==0 and size_x<origsize)
			size_x+=anim;
		end
		if(size_x>origsize)
			size_x=origsize;
		end
		if(size_x<0)
			size_x=0;
		end
	end
end
process knob(x,y,angle,size)
begin
	z=-3;
	size*=2;
	angle+=180;
	angle*=1000;
	resolution=10;
	graph=14;
	loop
		frame;
	end
end
process writeangle(x,y,string text,int angle);
begin
  angle*=1000;
  loop
    graph=write_in_map(0, text, 4);
    z=text_z;
    frame;
  end;
end;
function hit(ball);
begin
	signal(ball,s_kill);
	triggered=0;
	Ball();
end
process startlevel()
begin
	LET_ME_ALONE();
	readlevel("stdlevel.txt",++level);
	signal(father,s_kill);
	if(line[x]=="finish")
		finished();
		return;
	end
	if(line[x]=="bg")
		put_screen(0,atoi(line[++x])+13);
	end
	if(line[++x]=="ball")
		ballstart[0]=atoi(line[++x])*10;
		ballstart[1]=atoi(line[++x])*10;
		Ball();
	end
	if(line[++x]=="warps")
		while(line[++x]!="walls")
			warp(atoi(line[x])*10,atoi(line[++x])*10,atoi(line[++x]));
		end
	end
	if(line[x]=="walls")
		while(line[++x]!="triggers");
			wall(atoi(line[x])*10,atoi(line[++x])*10,atoi(line[++x]),atoi(line[++x]));
		end
	end
	if(line[x]=="triggers")
		while(line[++x]!="triggerknobs");
			trigger(atoi(line[x])*10,atoi(line[++x])*10,atoi(line[++x]));
		end
	end
	if(line[x]=="triggerknobs")
		while(line[++x]!="triggerwalls");
			knob(atoi(line[x])*10,atoi(line[++x])*10,atoi(line[++x]),atoi(line[++x]));
		end
	end
	if(line[x]=="triggerwalls")
		while(line[++x]!="");
			slider(atoi(line[x])*10,atoi(line[++x])*10,atoi(line[++x]),atoi(line[++x]),atoi(line[++x]),atoi(line[++x]));
		end
	end
end
process finished()
begin
	LET_ME_ALONE();
	writeangle(160,120,"Finished",270);
	while(key(_enter))
		frame;
	end
	loop
		if(key(_enter))
			level=0;
			triggered=0;
			startlevel();
		end 
		frame;
	end
end
/*
Reading the levelfile
*/
function readlevel(string filename,int readlevel)
private
textfile[10000];//we'll read up to 40000 chars
string chars[100];//up to 98 chars on a line (last two are for end of line)
string currentlevel;
string nextlevel;
lasttwo[2];
lastj;
j;
i;
found;
begin
for(i=0;i<=100;i++)
	line[i]="";
end;
i=0;
chars[0]="level";
chars[1]=itoa(readlevel);
currentlevel=join(" ",&chars,2);
chars[1]=itoa(readlevel+1);
nextlevel=join(" ",&chars,2);
load(filename,textfile);
while(j<4000)
	lasttwo[0]= (textfile[j/4]/power[j%4])%256;
	chars[j-lastj]=chr(lasttwo[0]);
	j++;
	lasttwo[1]= (textfile[j/4]/power[j%4])%256;
	chars[j-lastj]=chr(lasttwo[1]);
		while(lasttwo[0]!=44 and (lasttwo[1]!=10 or lasttwo[0]!=13)and j<4000 and j-lastj<100);
		  j++;                                                             
		  lasttwo[0]=lasttwo[1];
		  lasttwo[1]= (textfile[j/4]/power[j%4])%256;
		  chars[j-lastj]=chr(lasttwo[1]);
		end;
		j++;
		if(j-lastj==101);
		  return;
		end
		if(join("",&chars,j-lastj-2)==nextlevel)
		 	return;
		end;
		if(found == 1)
		 	line[i++]=join("",&chars,j-lastj-2);
		end
		if(join("",&chars,j-lastj-2)==currentlevel)
		 	found=1;
		end;
		if(join("",&chars,j-lastj-2)=="finish" and found == 0)
		 	line[0]="finish";
		 	return;
		end;
		lastj=j;
	end
	return;
end;